"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handler = void 0;
const next_connect_1 = __importDefault(require("next-connect"));
const middleware_1 = __importStar(require("./middleware"));
const onError_1 = require("./middleware/onError");
const onNoMatch_1 = require("./middleware/onNoMatch");
const mwHandle = (context, use, ...middleware) => {
    return use('/', ...middleware.map((ware) => (req, res, next) => __awaiter(void 0, void 0, void 0, function* () {
        return ware(context, next);
    })));
};
const handle = (context, action, handler) => action((req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const response = yield handler(context);
    return res.send(response);
}));
const setupContext = (context) => (req, res, next) => {
    req.ipAddress =
        (req.headers['x-forwarded-for'] || '').split(',').pop().trim() || req.socket.remoteAddress;
    context.req = req;
    context.res = res;
    return next();
};
const proxyHandler = {
    get: (_, method) => {
        const context = {
            user: null,
        };
        const instance = (0, next_connect_1.default)({ onNoMatch: onNoMatch_1.onNoMatch, onError: onError_1.onError }).use(setupContext(context));
        instance.get = handle.bind(null, context, instance.get);
        instance.head = handle.bind(null, context, instance.head);
        instance.options = handle.bind(null, context, instance.options);
        instance.post = handle.bind(null, context, instance.post);
        instance.put = handle.bind(null, context, instance.put);
        instance.patch = handle.bind(null, context, instance.patch);
        instance.delete = handle.bind(null, context, instance.delete);
        instance.use = mwHandle.bind(null, context, instance.use);
        return instance.use(...[...middleware_1.default, ...(0, middleware_1.autoload)()])[method].bind(instance);
    },
};
exports.handler = new Proxy((handler) => {
    const context = {
        user: null,
    };
    const instance = (0, next_connect_1.default)({ onNoMatch: onNoMatch_1.onNoMatch, onError: onError_1.onError }).use(setupContext(context));
    instance.use = mwHandle.bind(null, context, instance.use);
    return instance.use(...[...middleware_1.default, ...(0, middleware_1.autoload)()]).all((req, res) => __awaiter(void 0, void 0, void 0, function* () {
        const response = yield handler(context);
        return res.send(response);
    }));
}, proxyHandler);
exports.default = exports.handler;
//# sourceMappingURL=api-handler.js.map