"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
const log = __importStar(require("next/dist/build/output/log"));
const index_js_1 = __importDefault(require("next/dist/compiled/arg/index.js"));
const find_up_1 = require("next/dist/compiled/find-up");
const constants_1 = require("next/dist/lib/constants");
const utils_1 = require("next/dist/server/lib/utils");
const env_1 = require("@next/env");
const chalk_1 = __importDefault(require("chalk"));
const path_1 = require("path");
const utils_2 = require("./utils");
global.__$NEXT_SAAS__ = {};
global.__$NEXT_SAAS__.PWD = process.cwd();
global.__$NEXT_SAAS__.pkg = require((0, find_up_1.sync)('package.json', {
    cwd: global.__$NEXT_SAAS__.PWD,
}));
global.__$NEXT_SAAS__.config = global.__$NEXT_SAAS__.pkg['next-saas'] || {};
global.__$NEXT_SAAS__.autoload = (((_a = global.__$NEXT_SAAS__.pkg['next-saas']) === null || _a === void 0 ? void 0 : _a.autoload) || []).map((path) => {
    const { default: ware } = require((0, path_1.resolve)(global.__$NEXT_SAAS__.PWD, path));
    return ware;
});
(0, env_1.loadEnvConfig)(global.__$NEXT_SAAS__.PWD);
['react', 'react-dom'].forEach((dependency) => {
    try {
        require.resolve(dependency);
    }
    catch (err) {
        console.warn(`The module '${dependency}' was not found. Next.js requires that you include it in 'dependencies' of your 'package.json'. To add it, run 'npm install ${dependency}'`);
    }
});
const defaultCommand = 'dev';
const unsupportedCommand = (command) => () => {
    (0, utils_1.printAndExit)(`${chalk_1.default.red('>')} ${command} is an unsupported command in next-saas.`);
};
const commands = {
    build: () => Promise.resolve().then(() => __importStar(require('next/dist/cli/next-build'))).then((i) => i.nextBuild),
    export: () => Promise.resolve(unsupportedCommand('export')),
    telemetry: () => Promise.resolve().then(() => __importStar(require('next/dist/cli/next-telemetry'))).then((i) => i.nextTelemetry),
    lint: () => Promise.resolve().then(() => __importStar(require('next/dist/cli/next-lint'))).then((i) => i.nextLint),
    start: () => Promise.resolve().then(() => __importStar(require('./commands/start'))).then((i) => i.saasStart),
    dev: () => Promise.resolve().then(() => __importStar(require('./commands/dev'))).then((i) => i.saasDev),
    db: () => Promise.resolve().then(() => __importStar(require('./commands/db'))).then((i) => i.saasDb),
    worker: () => Promise.resolve().then(() => __importStar(require('./commands/worker'))).then((i) => i.saasWorker),
};
const args = (0, index_js_1.default)({
    '--version': Boolean,
    '--help': Boolean,
    '--inspect': Boolean,
    '-v': '--version',
    '-h': '--help',
}, {
    permissive: true,
});
if (args['--version']) {
    console.log(`Next SaaS v${require('../package.json').version}`);
    console.log(`Next.js v${require('next/package.json').version}`);
    console.log(`Prisma v${require('prisma/package.json').version}`);
    process.exit(0);
}
const foundCommand = Boolean(commands[args._[0]]);
if (!foundCommand && args['--help']) {
    console.log(`
    Usage
      $ saas <command>

    Available commands
      ${Object.keys(commands)
        .filter((command) => ['export'].includes(command))
        .join(', ')}

    Options
      --version, -v   Version number
      --help, -h      Displays this message
    
    For more information run a command with the --help flag
      $ saas build --help
  `);
    process.exit(0);
}
const command = foundCommand ? args._[0] : defaultCommand;
const forwardedArgs = foundCommand ? args._.slice(1) : args._;
if (args['--inspect'])
    throw new Error(`--inspect flag is deprecated. Use env variable NODE_OPTIONS instead: NODE_OPTIONS='--inspect' saas ${command}`);
if (args['--help']) {
    if (['db', 'worker'].includes(command)) {
        forwardedArgs.push('--help');
    }
    else {
        (0, utils_2.displayHelpForNextCommand)(command);
    }
}
const defaultEnv = command === 'dev' ? 'development' : 'production';
const standardEnv = ['production', 'development', 'test'];
if (process.env.NODE_ENV && !standardEnv.includes(process.env.NODE_ENV)) {
    log.warn(constants_1.NON_STANDARD_NODE_ENV);
}
process.env.NODE_ENV = process.env.NODE_ENV || defaultEnv;
process.on('SIGTERM', () => process.exit(0));
process.on('SIGINT', () => process.exit(0));
commands[command]().then((exec) => exec(forwardedArgs));
if (command === 'dev') {
    const { CONFIG_FILE } = require('next/dist/shared/lib/constants');
    const { watchFile } = require('fs');
    watchFile(`${process.cwd()}/${CONFIG_FILE}`, (cur, prev) => {
        if (cur.size > 0 || prev.size > 0) {
            console.log(`\n> Found a change in ${CONFIG_FILE}. Restart the server to see the changes in effect.`);
        }
    });
}
//# sourceMappingURL=cli.js.map