"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.saasDb = void 0;
const utils_1 = require("next/dist/server/lib/utils");
const saasDb = (argv) => __awaiter(void 0, void 0, void 0, function* () {
    const args = [];
    if (argv.length === 0 || argv.includes('--help')) {
        return (0, utils_1.printAndExit)('help');
    }
    if (argv.includes('migrate')) {
        args.push('migrate', process.env.NODE_ENV === 'production' ? 'deploy' : 'dev');
    }
    if (argv.includes('generate')) {
        args.push('generate');
    }
    const prismaBin = require.resolve('prisma');
    const prisma = require('cross-spawn').spawn(prismaBin, args, {
        stdio: 'inherit',
        env: process.env,
    });
    const code = yield require('p-event')(prisma, 'exit', { rejectionEvents: [] });
    process.exit(code);
});
exports.saasDb = saasDb;
//# sourceMappingURL=db.js.map