"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.saasStart = void 0;
const Log = __importStar(require("next/dist/build/output/log"));
const index_js_1 = __importDefault(require("next/dist/compiled/arg/index.js"));
const get_project_dir_1 = require("next/dist/lib/get-project-dir");
const is_error_1 = __importDefault(require("next/dist/lib/is-error"));
const utils_1 = require("next/dist/server/lib/utils");
const chalk_1 = __importDefault(require("chalk"));
const path_1 = require("path");
const start_server_1 = __importDefault(require("../start-server"));
const saasStart = (argv) => {
    const validArgs = {
        '--help': Boolean,
        '--port': Number,
        '--hostname': String,
        '-h': '--help',
        '-p': '--port',
        '-H': '--hostname',
    };
    let args;
    try {
        args = (0, index_js_1.default)(validArgs, { argv });
    }
    catch (error) {
        if ((0, is_error_1.default)(error) && error.code === 'ARG_UNKNOWN_OPTION') {
            return (0, utils_1.printAndExit)(error.message, 1);
        }
        throw error;
    }
    if (args['--help']) {
        console.log(`
      Description
        Starts the application in production mode.
        The application should be compiled with \`next build\` first.
      Usage
        $ next start <dir> -p <port>
      <dir> represents the directory of the Next.js application.
      If no directory is provided, the current directory will be used.
      Options
        --port, -p      A port number on which to start the application
        --hostname, -H  Hostname on which to start the application (default: 0.0.0.0)
        --help, -h      Displays this message
    `);
        process.exit(0);
    }
    const dir = (0, get_project_dir_1.getProjectDir)(args._[0]);
    let port = args['--port'] || (process.env.PORT && parseInt(process.env.PORT)) || 3000;
    const host = args['--hostname'] || '0.0.0.0';
    if (process.env.__NEXT_RAND_PORT) {
        port = 0;
    }
    (0, start_server_1.default)({ dir }, port, host)
        .then(({ app, actualPort, server }) => __awaiter(void 0, void 0, void 0, function* () {
        var _a, _b;
        const appUrl = `http://${host === '0.0.0.0' ? 'localhost' : host}:${actualPort}`;
        Log.ready(`started server on ${host}:${actualPort}, url: ${appUrl}`);
        yield app.prepare();
        if ((_b = (_a = global.__$NEXT_SAAS__.config) === null || _a === void 0 ? void 0 : _a.hooks) === null || _b === void 0 ? void 0 : _b['post-prepare']) {
            Log.info(`Loading hook:post-prepare ${chalk_1.default.dim(global.__$NEXT_SAAS__.config.hooks['post-prepare'])}`);
            require((0, path_1.resolve)(global.__$NEXT_SAAS__.PWD, global.__$NEXT_SAAS__.config.hooks['post-prepare'])).default({
                app,
                server,
            });
        }
    }))
        .catch((err) => {
        console.error(err);
        process.exit(1);
    });
};
exports.saasStart = saasStart;
//# sourceMappingURL=start.js.map