"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.saasWorker = void 0;
const log = __importStar(require("next/dist/build/output/log"));
const fs_1 = require("fs");
const path_1 = require("path");
const queue_1 = require("../queue");
const jobsDir = (0, path_1.resolve)(process.cwd(), 'jobs');
const saasWorker = () => {
    log.ready('started queue worker');
    const handlers = (0, fs_1.readdirSync)(jobsDir).reduce((handlers, filename) => {
        const { default: handler } = require((0, path_1.resolve)(jobsDir, filename));
        handlers[(0, path_1.basename)(filename, '.ts')] = handler;
        return handlers;
    }, {});
    queue_1.queue.work((job) => __awaiter(void 0, void 0, void 0, function* () {
        log.wait('processing...');
        try {
            yield handlers[job.data.$name](job);
            log.event('processed successfully');
        }
        catch (err) {
            log.error('processing failed');
            throw err;
        }
    }));
};
exports.saasWorker = saasWorker;
//# sourceMappingURL=worker.js.map