import { Request, Response } from './api-handler';
export declare class APIError<Data extends {} = Record<string, any>> extends Error {
    private statusCode;
    private type;
    private data?;
    constructor(message: string, statusCode: number, type: string, data?: Data);
    render(req: Request<any, any, any>, res: Response<any>): void;
}
export declare class BadRequestError<Data> extends APIError<Data> {
    constructor(message?: string, type?: string, data?: Data);
}
export declare class UnauthorizedError<Data> extends APIError<Data> {
    constructor(message?: string, type?: string, data?: Data);
}
export declare class NotFoundError<Data> extends APIError<Data> {
    constructor(message?: string, type?: string, data?: Data);
}
export declare class MethodNotAllowedError<Data> extends APIError<Data> {
    constructor(message?: string, type?: string, data?: Data);
}
export declare class ValidationError<Data> extends APIError<Data> {
    constructor(message?: string, type?: string, data?: Data);
}
export declare class InternalServerError<Data> extends APIError<Data> {
    constructor(message?: string, type?: string, data?: Data);
}
