"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.queue = exports.Queue = void 0;
const bull_1 = __importDefault(require("bull"));
class Queue {
    constructor() {
        this.bull = new bull_1.default(global.__$NEXT_SAAS__.pkg.name, {
            redis: process.env.REDIS_URL,
            prefix: 'next-saas',
        });
    }
    dispatch(name, data, options) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.bull.add(Object.assign({ $name: name }, data), options);
        });
    }
    work(handler) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.bull.process(handler);
        });
    }
}
exports.Queue = Queue;
exports.queue = new Queue();
//# sourceMappingURL=queue.js.map