"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const log_1 = require("next/dist/build/output/log");
const next_1 = __importDefault(require("next/dist/server/next"));
const http_1 = __importDefault(require("http"));
function start(serverOptions, port, hostname) {
    return __awaiter(this, void 0, void 0, function* () {
        let requestHandler;
        const srv = http_1.default.createServer((req, res) => {
            return requestHandler(req, res);
        });
        const app = (0, next_1.default)(Object.assign(Object.assign({}, serverOptions), { customServer: false, httpServer: srv }));
        requestHandler = app.getRequestHandler();
        yield new Promise((resolve, reject) => {
            let retryCount = 0;
            srv.on('error', (err) => {
                if (err.code === 'EADDRINUSE' && serverOptions.allowRetry && port && retryCount < 10) {
                    (0, log_1.warn)(`Port ${port} is in use, trying ${port + 1} instead.`);
                    port += 1;
                    retryCount += 1;
                    srv.listen(port, hostname);
                }
                else {
                    reject(err);
                }
            });
            srv.on('listening', () => resolve());
            srv.listen(port, hostname);
        });
        const addr = srv.address();
        return {
            app,
            server: srv,
            actualPort: addr && typeof addr === 'object' ? addr.port : port,
        };
    });
}
exports.default = start;
//# sourceMappingURL=start-server.js.map